//----------------------//
// DeathEffectSpawner   //
//----------------------//

class DeathEffectSpawner extends Actor;

var float SpawnDelay;
var int SpawnsLeft;
var bool bIsSpawning;
var vector RelLocation;
var class<Effects> EffectToSpawn;

function StopSpawner()
{
	SetTimer(0.0, false);
	bIsSpawning = false;
}

function StartSpawner()
{
	if (bIsSpawning)
	{
		StopSpawner();
	}
	bIsSpawning = true;
	SetTimer(SpawnDelay, true);
	if (class'MoreBloodConfig'.Default.bDebugMode)
	{
		log("Owner: "@Owner$"  Owner.Location: "@Owner.Location$"   Location: "@Location$"   Relocation: "@RelLocation);
		log("DeathEffect:  "@EffectToSpawn);
	}
}

function InitSpawner()
{
	if (Location.Z != 0.0)
	{
		RelLocation = Location - Owner.Location;
	}
}

function SetSpawnProperties(optional float SD, optional int SL, optional class<Effects> E)
{
	SpawnDelay = FMin(SD, 5.0);
	SpawnsLeft = Min(SL, 50);
	EffectToSpawn = E;
	StartSpawner();
}

function Timer()
{
	if ((Owner != None) && (bIsSpawning))
	{
		Spawn(EffectToSpawn, Self, , RelLocation + Owner.Location, Owner.Rotation);
		SpawnsLeft--;
		if ((SpawnsLeft <= 0) || (Pawn(Owner).health > 0))
		{
			StopSpawner();
			Destroy();
		}
	}
}

defaultproperties
{
	bHidden=True
}
