//--------------------------------------//
// MoreBlood  2010 - Mr.Loathsome       //
// Players bleed where they take damage //
// Based on the Bleeder mutator         //
//--------------------------------------//
class MB expands Mutator;

var bool bRandomMode;
var bool bDebugMode;
var bool bDeathEffect;
var bool bPulseDrop;
var int MaxBleeders;
var float BleedTime;
var float BDLifeSpan;
var float BDDrawScale;
var float SpurtLevel;
var int MaxBleedersRV;
var int BleedTimeRV;
var float BDLifeSpanRV;
var float BDDrawScaleRV;
var float SpurtLevelRV;

var bool bInitialized;

function PostBeginPlay()
{
	if (bInitialized) return;
	else bInitialized = True;
	Level.Game.RegisterDamageMutator(Self);
	bRandomMode = class'MoreBloodConfig'.Default.bRandomMode;
	bDebugMode = class'MoreBloodConfig'.Default.bDebugMode;
	bDeathEffect = class'MoreBloodConfig'.Default.bDeathEffect;
	bPulseDrop = class'MoreBloodConfig'.Default.bPulseDrop;
	MaxBleeders = class'MoreBloodConfig'.Default.MaxBleeders;
	BleedTime = class'MoreBloodConfig'.Default.BleedTime;
	BDLifeSpan = class'MoreBloodConfig'.Default.BDLifeSpan;
	BDDrawScale = class'MoreBloodConfig'.Default.BDDrawScale;
	SpurtLevel = class'MoreBloodConfig'.Default.SpurtLevel;

	if (bRandomMode)
	{
		MaxBleedersRV = class'MoreBloodConfig'.Default.MaxBleedersRV;
		BleedTimeRV = class'MoreBloodConfig'.Default.BleedTimeRV - (class'MoreBloodConfig'.Default.BleedTimeRV / 5);
		BDLifeSpanRV = class'MoreBloodConfig'.Default.BDLifeSpanRV - (class'MoreBloodConfig'.Default.BDLifeSpanRV / 5);
		BDDrawScaleRV = class'MoreBloodConfig'.Default.BDDrawScaleRV - (class'MoreBloodConfig'.Default.BDDrawScaleRV / 5);
		SpurtLevelRV = class'MoreBloodConfig'.Default.SpurtLevelRV - (class'MoreBloodConfig'.Default.SpurtLevelRV / 5);

		MaxBleeders = (FRand()*MaxBleedersRV) + 1;
		BleedTime = (FRand() * BleedTimeRV) + (BleedTimeRV / 5) + 1.0;
		BDLifeSpan = (FRand() * BDLifeSpanRV) + (BDLifeSpanRV / 5) + 1.0;
		BDDrawScale = (FRand() * BDDrawScaleRV) + (BDDrawScaleRV / 5) + 0.125;
		SpurtLevel = (FRand() * SpurtLevelRV) + (SpurtLevelRV / 5);
		if (MaxBleeders > 80) MaxBleeders = 80;
		if (BleedTime > 80.0) BleedTime = 80.0;
		if (BDLifeSpan > 255) BDLifeSpan = 255;
		if (BDDrawScale > 1) BDDrawScale = 1;
		class'MoreBloodConfig'.Default.MaxBleeders = MaxBleeders;
		class'MoreBloodConfig'.Default.BleedTime = BleedTime;
		class'MoreBloodConfig'.Default.BDLifeSpan = BDLifeSpan;
		class'MoreBloodConfig'.Default.BDDrawScale = BDDrawScale;
		class'MoreBloodConfig'.Default.SpurtLevel = SpurtLevel;
		class'MoreBloodConfig'.static.StaticSaveConfig();				
	}
	else
	{
		if (MaxBleeders > 80) MaxBleeders = 80;
		if (BleedTime > 80.0) BleedTime = 80.0;
		if (BDLifeSpan > 255) BDLifeSpan = 255;
		if (BDDrawScale > 1) BDDrawScale = 1;
	}
	if (bDebugMode)
		log("MaxBleeders = "$MaxBleeders$"  BleedTime = "$BleedTime$"  BDLifeSpan = "$BDLifeSpan$"  BDDrawScale = "$BDDrawScale$"  SpurtLevel = "$SpurtLevel);

		
	Super.PostBeginPlay();
}

function MutatorTakeDamage(out int ActualDamage, Pawn Victim, Pawn InstigatedBy, out Vector HitLocation, out Vector Momentum, name DamageType)
{
	local BleederEffectSpawner BES;
	local class<Effects> EffS;
	local int i, j, nb, rv;

	if (ActualDamage > 0)
	{
	if ((Victim.Health - ActualDamage) <= 0)
		{
		 if ((bDeathEffect) && (ActualDamage < 30) && (ScriptedPawn(Victim) == None))
			DeathEffect(Victim);
		}
		else
		{
			nb = NumBleeders(Victim);
			if (bDebugMode)
				log(Victim$"  Health = "$Victim.health$"  defaultHealth = "$Victim.default.health$"   NumBleeders = "$nb$"   ActualDamage = "$ActualDamage);
			if ((nb < MaxBleeders) && (nb <= (Victim.health * 0.10)))
			{
				BES = Spawn(class'BleederEffectSpawner', Victim, , HitLocation, Victim.Rotation);
				if (BES != None)
				{
					j = ActualDamage * BleedTime;
					j = j * 2;
					BES.InitSpawner();
					if ((ScriptedPawn(Victim) != None) && (ScriptedPawn(Victim).bGreenBlood))
					{
						rv = (FRand()*5);
						Switch(rv)
						{
							case 4:
								EffS = class'UTB_GBloodDrop';
								break;
							case 3:
								EffS = class'UTB_GBloodDrop';
								break;
							case 2:
								EffS = class'GreenBlob';
								break;
							case 1:
								EffS = class'GreenBloodPuff';
								break;
							case 0:
								EffS = class'GreenBloodSpray';
								break;
						}
					}
					else
					{
						rv = (FRand()*13);
						Switch(rv)
						{
							case 12:
								EffS = class'UT_BigBloodPuff';
								break;
							case 11:
								EffS = class'UT_BigBloodHit';
								break;
							case 10:
								EffS = class'UT_BloodBurst';
								break;
							case 9:
								EffS = class'UT_BloodHit';
								break;
							case 8:
								EffS = class'UT_BloodPuff';
								break;
							case 7:
								EffS = class'UTB_BloodDrop';
								break;
							case 6:
								EffS = class'UTB_BloodDrop2';
								break;
							case 5:
								EffS = class'UTB_BloodDrop3';
								break;
							case 4:
								EffS = class'UTB_BloodDrop2';
								break;
							case 3:
								EffS = class'BloodSpurt';
								break;
							case 2:
								EffS = class'BloodPuff';
								break;
							case 1:
								EffS = class'BloodBurst';
								break;
							case 0:
								EffS = class'BloodSpray';
								break;
						}
					}
					if (bDebugMode)
						log("Spawns (j) = "@j$"   Effect = "@Effs);
					BES.SetSpawnProperties(FMin((FRand() + 0.125), 0.8), j, EffS);
					BES = None;
				}
			}
		}
	}
	Super.MutatorTakeDamage(ActualDamage, Victim, InstigatedBy, HitLocation, Momentum, DamageType);
}

function int NumBleeders(Pawn Other)
{
	local BleederEffectSpawner BES;
	local int nb;

	nb = 0;
	foreach Other.ChildActors(class'BleederEffectSpawner', BES)
	{
		nb++;
	}
	return nb;
}

function DeathEffect(Pawn Other)
{
	local DeathEffectSpawner DES;
	local class<Effects> EffS;
	local float sdtime;

	sdtime = FMin((FRand() + 0.125), 0.6);

	DES = Spawn(class'DeathEffectSpawner', Other, , Other.Location, Other.Rotation);
	DES.InitSpawner();
	EffS = class'UTB_BloodDrop2';
	DES.SetSpawnProperties(sdtime, 60, EffS);

	DES = Spawn(class'DeathEffectSpawner', Other, , Other.Location, Other.Rotation);
	DES.InitSpawner();
	EffS = class'UTB_BloodDrop3';
	DES.SetSpawnProperties(sdtime, 40, EffS);

	DES = Spawn(class'DeathEffectSpawner', Other, , Other.Location, Other.Rotation);
	DES.InitSpawner();
	EffS = class'UT_BlackSmoke';
	DES.SetSpawnProperties(sdtime, 30, EffS);

	DES = Spawn(class'DeathEffectSpawner', Other, , Other.Location, Other.Rotation);
	DES.InitSpawner();
	EffS = class'BloodSpurt';
	DES.SetSpawnProperties(sdtime, 8, EffS);

	DES = Spawn(class'DeathEffectSpawner', Other, , Other.Location, Other.Rotation);
	DES.InitSpawner();
	EffS = class'BloodSpray';
	DES.SetSpawnProperties(sdtime, 6, EffS);

	DES = Spawn(class'DeathEffectSpawner', Other, , Other.Location, Other.Rotation);
	DES.InitSpawner();
	EffS = class'UTB_BloodTrail';
	DES.SetSpawnProperties(sdtime, 3, EffS);

	DES = Spawn(class'DeathEffectSpawner', Other, , , Other.Rotation);
	DES.InitSpawner();
	EffS = class'UTB_BloodTrail';
	DES.SetSpawnProperties(sdtime, 2, EffS);

	DES = Spawn(class'DeathEffectSpawner', Other, , , );
	DES.InitSpawner();
	EffS = class'UTB_BloodPool';
	DES.SetSpawnProperties(sdtime, 1, EffS);
}

defaultproperties
{
	bRandomMode=True
	bDebugMode=False
	bDeathEffect=True
	bPulseDrop=True
	MaxBleeders=5
	BleedTime=2.5
	BDLifeSpan=15.0
	BDDrawScale=0.25000
	SpurtLevel=45
	MaxBleedersRV=15
	BleedTimeRV=3.0
	BDLifeSpanRV=85.0
	BDDrawScaleRV=0.35000
	SpurtLevelRV=120
	bHidden=True
}
