//=============================================================================
// utb_BloodDrop.
//=============================================================================
class UTB_BloodDrop extends Blood2;

var bool bPulse, bPulseUp, bInit;
var int PulseCnt;
var float Pinc;

simulated function PostBeginPlay()
{
	Velocity = (Vector(Rotation) + VRand()) * (((FRand() * class'MoreBloodConfig'.default.SpurtLevel) + class'MoreBloodConfig'.default.SpurtLevel));
	Velocity.z += (FRand()*class'MoreBloodConfig'.default.SpurtLevel) + 1;
	Texture = MultiSkins[(FRand()*8)];
	Drawscale = (FRand()*class'MoreBloodConfig'.default.BDDrawScale) + 0.0125;
	LifeSpan = class'MoreBloodConfig'.default.BDLifeSpan;
	bPulse = class'MoreBloodConfig'.default.bPulseDrop;
	if ((bPulse) && (Level.NetMode != NM_DedicatedServer))
	{
		bPulseUp = True;
		bInit = False;
		PulseCnt = 0;
		Pinc = (class'MoreBloodConfig'.default.BDDrawScale * 0.05);
		SetTimer((FRand() * 0.4) + 0.01, true);
	}
	if (Level.NetMode != NM_DedicatedServer)
	{
		SpawnDrop();
	}
}

simulated function Timer()
{
	PulseDrop();
}

simulated function SpawnDrop()
{
	local Actor A;

	A = spawn(class'UT_BloodDrop');
	A.RemoteRole = ROLE_SimulatedProxy;
}

simulated function PulseDrop()
{
	if (bPulseUp)
		{
			if (Drawscale < (class'MoreBloodConfig'.default.BDDrawScale))
				Drawscale = Drawscale + Pinc;
			PulseCnt++;
			if (PulseCnt >= 10) bPulseUp = False;
		}
	else
		{
			if (Drawscale > 0.0125)
				Drawscale = Drawscale - Pinc;
			PulseCnt--;
			if (PulseCnt == 0) bPulseUp = True;
		}
}

defaultproperties
{
     bHighDetail=True
     Physics=PHYS_Falling
     bStatic=False
     LifeSpan=3.500000
     DrawType=DT_Sprite
     Style=STY_Masked
     Texture=Texture'Botpack.Blood.BD3'
     DrawScale=0.250000
     AmbientGlow=180
     MultiSkins(0)=Texture'Botpack.Blood.BD3'
     MultiSkins(1)=Texture'Botpack.Blood.BD4'
     MultiSkins(2)=Texture'Botpack.Blood.BD6'
     MultiSkins(3)=Texture'Botpack.Blood.BD9'
     MultiSkins(4)=Texture'Botpack.Blood.BD10'
     MultiSkins(5)=Texture'Botpack.Blood.BD3'
     MultiSkins(6)=Texture'Botpack.Blood.BD4'
     MultiSkins(7)=Texture'Botpack.Blood.BD6'
     bCollideWorld=True
     bBounce=True
     NetPriority=2.000000
}
