//=============================================================================
// utb_BloodDrop3.   Bouncy moving drops
//=============================================================================
class UTB_BloodDrop3 extends UTB_BloodDrop;

var int g, r;
var vector prevloc;

simulated function PostBeginPlay()
{
	r = (class'MoreBloodConfig'.default.SpurtLevel * 0.5) + 1;
	prevloc = Self.Location;
	Super.PostBeginPlay();
}

simulated function HitWall( vector HitNormal, actor Wall )
{
   if (Level.NetMode != NM_DedicatedServer)
	if ((prevloc.x != Self.Location.x) && (prevloc.y != Self.Location.y))
	{
	  	if (Velocity.z >= -255.0)
		{
			Velocity.z += r++;
			Velocity.z *= -1;
		}
		prevloc = Self.Location;
	}
}

defaultproperties
{
     bHighDetail=True
     Physics=PHYS_Falling
     bStatic=False
     LifeSpan=3.500000
     DrawType=DT_Sprite
     Style=STY_Masked
     Texture=Texture'Botpack.Blood.BD3'
     DrawScale=0.250000
     AmbientGlow=180
     MultiSkins(0)=Texture'Botpack.Blood.BD3'
     MultiSkins(1)=Texture'Botpack.Blood.BD4'
     MultiSkins(2)=Texture'Botpack.Blood.BD6'
     MultiSkins(3)=Texture'Botpack.Blood.BD9'
     MultiSkins(4)=Texture'Botpack.Blood.BD10'
     MultiSkins(5)=Texture'Botpack.Blood.BD3'
     MultiSkins(6)=Texture'Botpack.Blood.BD4'
     MultiSkins(7)=Texture'Botpack.Blood.BD6'
     bCollideWorld=True
     bBounce=True
     NetPriority=2.000000
}
